if (global.connected)
	{
	var cx = 4; var cy = 4;
	var cw = 128; var ch = 112;
	var row = 0; var col = 0;
	draw_set_halign(1);
	for(var i=0; i<max_user; i++;)
		{
		if !(connected[i])
			continue;
		
		var w = min(cx,cur_user-col*cy)*64 + min(cx-1,max(0,(cur_user-1)-col*cy))*(cw-64);
		var dx = rw/2 - w/2 + row*cw;
		var dy = 80 + col*ch;
	
		var temp_info = playback_info[i];
		var name = temp_info[?"name"];
		var img = temp_info[?"img"];
		var amp = temp_info[?"amp"];
	
		var active = (amp > gate);
		if (img == -1)
			{
			// draw loading circles
			draw_set_color(ui_col.def);
			var s = 4+sin(current_time/500)*3;
			var a = current_time/20;
			for(var i=0; i<ceil(s); i++;)
				{
				var ldx = lengthdir_x(24,a + (360/s)*i);
				var ldy = lengthdir_y(24,a + (360/s)*i);
				draw_circle(dx+32+ldx,dy+32+ldy,3,0);
				}
			}
		else
			{
			// draw sprite
			if (sprite_exists(img))
				{
				if (active)
					draw_set_color(ui_col.act);
				else
					draw_set_color(ui_col.bg);
				draw_rectangle(dx-2,dy-2,dx+65,dy+65,0);
				draw_sprite(img,0,dx,dy);
				}
			}
		if (string_width(name) > 112)
			{
			while(string_width(string(name)+"...") > 112)
				name = string_copy(name,1,string_length(name)-1);
			name = string(name)+"...";
			}
		if (active)
			draw_set_color(ui_col.act);
		else
			draw_set_color(ui_col.alt);
		draw_text(dx+32,dy+72,name);
	
		row++;
		if (row >= cx)
			{
			row = 0;
			col++;
			}
		}
	draw_set_halign(0);
	
	var time = get_timer();
	chat_alpha += (((time-chat_time < 7*sec) or (chat_box.select))-chat_alpha)*0.25;
	}
else
	chat_alpha += (1-chat_alpha)*0.25;

if (chat_alpha > 0)
	{
	draw_set_alpha(chat_alpha);
	draw_set_color($121212);
	draw_rectangle(32,rh-172,32+chat_w,rh-49,0);
	draw_set_color($FFFFFF);
	for(var i=0; i<ds_list_size(chat_list); i++;)
		{
		var text = string(chat_list[|i]);
		if (string_width(text) > chat_w-6)
			{
			while(string_width(string(text)+"...") > chat_w-6)
				text = string_copy(text,1,string_length(text)-1);
			text = string(text)+"...";
			}
		draw_text(32+6,rh-72 - 24*i,text);
		}
	draw_set_alpha(1.0);
	}