var p_queue = async_load[?"queue_id"];
var p_buff  = async_load[?"buffer_id"];
var p_stop  = async_load[?"queue_shutdown"];

if !(playback)
	exit;

if (p_stop)
	{
	// audio_free_play_queue() called, clean up a bit
	for(var i=0; i<max_user; i++;)
		{
		if (playback_queue[i] == p_queue)
			{
			// stop
			}
		}
	}
else
	{
	// audio buffer in a queue just finished playing
	for(var i=0; i<max_user; i++;)
		{
		if (playback_queue[i] != p_queue)
			continue;
		
		for(var j=0; j<4; j++;)
			{
			if (playback_buffer[i,j] != p_buff)
				continue;
			
			if (ds_list_size(unzipped_list[i]) > 0)
				{
				var temp_buff = ds_list_find_value(unzipped_list[i],0);
				var temp_size = buffer_get_size(temp_buff);
				
				if (buffer_get_size(playback_buffer[i,j]) != temp_size)
					buffer_resize(playback_buffer[i,j],temp_size);
				
				var amp = 0;
				for(var k=0; k<temp_size; k++;)
					{
					var val = buffer_peek(temp_buff,k,buffer_u8);
					amp = max(amp,val);
					
					buffer_poke(playback_buffer[i,j],k,buffer_u8,val);
					}
				
				audio_queue_sound(playback_queue[i],playback_buffer[i,j],0,temp_size);
				
				buffer_delete(temp_buff);
				ds_list_delete(unzipped_list[i],0);
				
				ds_map_set(playback_info[i],"amp",(amp/255) / ((1/0.9 - 2)*(1-(amp/255))+1));
				exit;
				}
			else
				{
				if (global.connected) and !(playback_quiet[i])
					{
					playback_quiet[i] = true;
					
					// no new data, fill playback buffer with empty value
					var temp_size = buffer_get_size(playback_buffer[i,j]);
					for(var k=0; k<temp_size; k++;)
						buffer_poke(playback_buffer[i,j],k,buffer_u8,0);
				
					audio_queue_sound(playback_queue[i],playback_buffer[i,j],0,temp_size);
				
					ds_map_set(playback_info[i],"amp",0);
					}
				else
					{
					playback_quiet[i] = false;
					if (playback_audio[i] > -1)
						{
						audio_stop_sound(playback_audio[i]);
						playback_audio[i] = -1;
						}
					if (playback_queue[i] > -1)
						{
						audio_free_play_queue(playback_queue[i]);
						playback_queue[i] = -1;
						}
					}
				exit;
				}
			}
		}
	}