menu_process();

if (global.connected)
	{
	// audio recording
	transmit = ((ptt) and (keyboard_check(vk_space)) and !(chat_box.select)) or !(ptt);

	if (transmit)
		{
		if (record_channel == -1) and (device_index >= 0)
			{
			record_channel = audio_start_recording(device_index);
			show_debug_message("OBJ_CHAT_CONTROL: RECORDING STARTED");
			}
		}

	// uncompress data and queue buffers
	for(var i=0; i<max_user; i++;)
		{
		while(ds_queue_size(zipped_queue[i]) > 0)
			{
			var temp_buff = buffer_decompress(ds_queue_dequeue(zipped_queue[i]));
			if (temp_buff >= 0)
				ds_list_add(unzipped_list[i],temp_buff);
			}
	
		if (ds_list_size(unzipped_list[i]) >= 8)
			{
			// create and queue the playback queue
			if (playback_queue[i] == -1)
				{
				playback_queue[i] = audio_create_play_queue(transmit_format,playback_sample[i],audio_mono);
				
				for(var j=0; j<4; j++;)
					{
					var buff = ds_list_find_value(unzipped_list[i],0);
					var size = buffer_get_size(buff);
					if !(buffer_exists(playback_buffer[i,j]))
						playback_buffer[i,j] = buffer_create(size,buffer_fixed,1);
					if (buffer_get_size(playback_buffer[i,j]) != size)
						buffer_resize(playback_buffer[i,j],size);
					
					buffer_copy(buff,0,size,playback_buffer[i,j],0);
					
					audio_queue_sound(playback_queue[i],playback_buffer[i,j],0,size);
					
					buffer_delete(buff);
					ds_list_delete(unzipped_list[i],0);
					}
				}
			// start playing the sound if it isn't playing
			if (playback_audio[i] == -1)
				playback_audio[i] = audio_play_sound(playback_queue[i],0,true);
			else if !(audio_is_playing(playback_audio[i]))
				playback_audio[i] = audio_play_sound(playback_queue[i],0,true);
			}
		}

	if (user_id > -1)
		{
		chat_box.disabled = false;
		if (keyboard_check_pressed(vk_enter)) or (chat_btn.output)
			{
			if (chat_box.output != "")
				{
				var chat = chat_box.output;
				with(obj_client)
					{
					var send_buffer = buffer_create(16+256,buffer_fixed,1);
					buffer_seek(send_buffer,buffer_seek_start,0);
					buffer_write(send_buffer,buffer_u8,user_message.user_message);
					buffer_write(send_buffer,buffer_string,chat);
					user_queue_message(send_buffer);
					}
				chat_box.output = "";
				}
			}
		chat_btn.disabled = (chat_box.output == "")
		}
	else
		{
		chat_box.disabled = true;
		chat_btn.disabled = true;
		}
	}
else
	{
	transmit = false;
	chat_box.disabled = true;
	chat_btn.disabled = true;
	}

if (ds_list_size(chat_list) > 5)
	{
	while(ds_list_size(chat_list) > 5)
		ds_list_delete(chat_list,ds_list_size(chat_list)-1);
	}

if (global.user_update_callback)
	{
	global.user_update_callback = false;
	event_user(0);
	}