time = get_timer();

if !(global.connected) and (user_id == -1)
	{
	if (time-retry_time >= sec)
		{
		retry_time = time;
		
		var send_buffer = buffer_create(64,buffer_fixed,1);
		buffer_seek(send_buffer,buffer_seek_start,0);
		buffer_write(send_buffer,buffer_u8,1);
		buffer_write(send_buffer,buffer_u8,user_message.welcome);
		buffer_write(send_buffer,buffer_u8,69);
		buffer_write(send_buffer,buffer_string,name);
		var size = buffer_tell(send_buffer);
		network_send_udp_raw(socket,server_ip,server_port,send_buffer,size);
		buffer_delete(send_buffer);
		
		data_t += size;
		pack_t++;
		}
	}

// connection info
if (data_t_array[data_index] > data_array_max)
	data_array_max = ceil(data_t_array[data_index]/1024)*1024;
if (data_r_array[data_index] > data_array_max)
	data_array_max = ceil(data_r_array[data_index]/1024)*1024;
data_index++;
if (data_index > 179)
	data_index = 0;
data_t_array[data_index] = 0;
data_r_array[data_index] = 0;

if (time-stats_time >= sec)
	{
	stats_time = time;
	
	total_data_t += data_t; total_data_r += data_r;
	total_pack_t += pack_t; total_pack_r += pack_r;
	data_t = 0; data_r = 0;
	pack_t = 0; pack_r = 0;
	}

// connection info
if (time-img_time >= sec/20) and (global.connected)
	{
	img_time = time;
	
	// attempt to upload our own image
	if !(img_uploaded)
		{
		var sectors = img_upload_sectors;
		for(var i=0; i<16; i++;)
			{
			if (sectors == sectors | (1 << i))
				continue;
			
			var sector = i;
			
			var temp_buffer = buffer_create(16+512,buffer_fixed,1);
			buffer_seek(temp_buffer,buffer_seek_start,0);
			buffer_write(temp_buffer,buffer_u8,user_message.user_image_upload);
			buffer_write(temp_buffer,buffer_u8,sector);
			
			for(var iy=sector*4; iy<sector*4+4; iy++;)
				{
				for(var ix=0; ix<64; ix++;)
					buffer_write(temp_buffer,buffer_u16,ds_grid_get(img_data,ix,iy));
				}
			
			user_queue_message(temp_buffer);
			break;
			}
		}
	
	// attempt to download other user images
	if (img_download == -1)
		{
		for(var i=0; i<max_user; i++;)
			{
			if !(connected[i])
				continue;
			
			if !(ds_map_find_value(user_info[i],"img_ready"))
				{
				img_download = i;
				
				var sectors = ds_map_find_value(user_info[i],"img_sectors");
				for(var j=0; j<16; j++;)
					{
					if (sectors == sectors | (1 << j))
						continue;
					
					var temp_buffer = buffer_create(16,buffer_fixed,1);
					buffer_seek(temp_buffer,buffer_seek_start,0);
					buffer_write(temp_buffer,buffer_u8,user_message.user_image_download);
					buffer_write(temp_buffer,buffer_u8,i);
					buffer_write(temp_buffer,buffer_u8,j);
					user_queue_message(temp_buffer);
					
					break;
					}
				break;
				}
			}
		}
	else
		{
		if (connected[img_download])
			{
			if !(ds_map_find_value(user_info[img_download],"img_ready"))
				{
				var sectors = ds_map_find_value(user_info[img_download],"img_sectors");
				for(var i=0; i<16; i++;)
					{
					if (sectors == sectors | (1 << i))
						continue;
					
					var temp_buffer = buffer_create(16,buffer_fixed,1);
					buffer_seek(temp_buffer,buffer_seek_start,0);
					buffer_write(temp_buffer,buffer_u8,user_message.user_image_download);
					buffer_write(temp_buffer,buffer_u8,img_download);
					buffer_write(temp_buffer,buffer_u8,i);
					user_queue_message(temp_buffer);
					
					break;
					}
				}
			}
		else
			img_download = -1;
		}
	
	for(var i=0; i<max_user; i++;)
		{
		if !(connected[i])
			continue;
		
		var info_map = user_info[i];
		if ((info_map[?"img"] == -1) and (info_map[?"img_ready"]))
			{
			var temp_data = info_map[?"img_data"];
			
			var surf = surface_create(64,64);
			surface_set_target(surf);
			draw_clear($000000);
			
			for(var iy=0; iy<64; iy++;)
				{
				for(var ix=0; ix<64; ix++;)
					{
					var byte = ds_grid_get(temp_data,ix,iy);
					var hue = (byte)		& 63;
					var sat = (byte >> 6)	& 15;
					var val = (byte >> 10)	& 63;
					draw_point_color(ix,iy,make_color_hsv((hue/63)*255,(sat/15)*255,(val/63)*255));
					}
				}
			
			surface_reset_target();
			
			info_map[?"img"] = sprite_create_from_surface(surf,0,0,64,64,0,0,0,0);
			surface_free(surf);
			
			global.user_update_callback = true;
			break;
			}
		}
	}

// merge and send out queued messages
if ((global.connected) and (messages > 0))
	{
	var send_buffer = buffer_create(MTU,buffer_fixed,1); // buffer_create(MTU,buffer_fixed,1);
	
	var index = 0;
	var bytes = 1;
	var num = 0;
	do
		{
		var buff = ds_list_find_value(message_list,index*2 + 0);
		var size = ds_list_find_value(message_list,index*2 + 1);
		
		if (bytes+size >= MTU) // too big, skip it
			index++;
		else
			{
			buffer_copy(buff,0,size,send_buffer,bytes);
			buffer_delete(buff);
			
			repeat(2)
				ds_list_delete(message_list,index*2);
			messages--;
			
			bytes += size;
			num++;
			}
		}
	until (index >= messages)
	
	if (num > 0)
		{
		buffer_poke(send_buffer,0,buffer_u8,num);
		
		network_send_udp_raw(socket,server_ip,server_port,send_buffer,bytes);
		
		data_t += bytes;
		pack_t += 1;
		data_t_array[data_index] += bytes;
		}
	
	buffer_delete(send_buffer);
	}

if (keyboard_check_pressed(vk_f1))
	stats_graph = !stats_graph;