macros_and_enums();
load_profile();

rw = room_width;
rh = room_height;

menu_init();

// main menu
menu_add_page("Connect");
var item = menu_add_item(128,160,obj_description,false,"Hosting or joining a server?");
var item = menu_add_item(128,192,obj_button,false,"Host");
menu_edit_item(item,"w",96,"h",32);
var item = menu_add_item(256,192,obj_button,false,"Join");
menu_edit_item(item,"w",96,"h",32);

menu_add_page("Host a Server");
var item = menu_add_item(128,160,obj_description,false,"Enter a server name");
var item = menu_add_item(128,192,obj_textbox,global.server_name);
menu_edit_item(item,"w",256,"h",32);
var item = menu_add_item(448,160,obj_description,false,"Enter a port number");
var item = menu_add_item(448,192,obj_textbox,string(global.server_port));
menu_edit_item(item,"w",96,"h",32);
var item = menu_add_item(128,256,obj_description,false,"Select an audio quality");
var item = menu_add_item(128,288,obj_dropdown,global.server_format);
menu_edit_item(item,"w",192,"h",32);
item.items = 2;
item.item[0] = "8-Bit";
item.item[1] = "16-Bit";
var item = menu_add_item(128,320,obj_description,false,"Select a downsample filter");
var item = menu_add_item(128,352,obj_dropdown,global.server_downsample);
menu_edit_item(item,"w",192,"h",32);
item.items = 2;
item.item[0] = "Original";
item.item[1] = "2x Downsampled";
var item = menu_add_item(128,rh-64,obj_button,false,"Back");
menu_edit_item(item,"w",96,"h",32);
var item = menu_add_item(rw-256,rh-64,obj_button,false,"Start Server");
menu_edit_item(item,"w",128,"h",32);
menu_add_item(128,384,obj_description,false,"","Lower bitrates and downsampling reduce quality to save bandwidth");

// username
menu_add_page("Profile");
var item = menu_add_item(128,160,obj_description,false,"Enter your username"," (4 - 32 characters)");
var item = menu_add_item(128,192,obj_textbox,global.name,"Username");
menu_edit_item(item,"w",256,"h",32);
var item = menu_add_item(128,256,obj_description,false,"Select an avatar"," (or stick with the default one)");
var item = menu_add_item(128,288,obj_button,false,"Browse");
menu_edit_item(item,"w",96,"h",32);
var item = menu_add_item(128,rh-64,obj_button,false,"Back");
menu_edit_item(item,"w",96,"h",32);
var item = menu_add_item(rw-224,rh-64,obj_button,false,"Continue");
menu_edit_item(item,"w",96,"h",32);

menu_add_page("Audio Setup");
var item = menu_add_item(128,160,obj_description,false,"Select an input device"," (so others can hear you)");
var item = menu_add_item(128,192,obj_dropdown,0);
menu_edit_item(item,"w",256,"h",32);
var item = menu_add_item(128,256,obj_description,false,"Microphone Volume: "+string(round(global.gain*100))+"%");
var item = menu_add_item(128,288,obj_slider,global.gain);
menu_edit_item(item,"w",256,"h",16);
var item = menu_add_item(128,320,obj_description,false,"Noise Gate: "+string(round(global.gate*100))+"%");
var item = menu_add_item(128,352,obj_slider,global.gate);
menu_edit_item(item,"w",256,"h",16);
var item = menu_add_item(128,384,obj_description,false,"Record mode"," (Push to Talk: [SPACE] to activate mic)");
var item = menu_add_item(128,416,obj_dropdown,global.ptt);
menu_edit_item(item,"w",256,"h",32);
item.items = 2;
item.item[0] = "Always On";
item.item[1] = "Push to Talk";
var item = menu_add_item(128,rh-64,obj_button,false,"Back");
menu_edit_item(item,"w",96,"h",32);
var item = menu_add_item(rw-256,rh-64,obj_button,false,"Continue");
menu_edit_item(item,"w",128,"h",32);

menu_add_page("Join a Server");
var item = menu_add_item(128,160,obj_description,false,"Enter server info below"," (ctrl+v to paste text)");
var item = menu_add_item(128,192,obj_textbox,global.connect_ip);
menu_edit_item(item,"w",256,"h",32);
var item = menu_add_item(128,256,obj_textbox,string(global.connect_port));
menu_edit_item(item,"w",96,"h",32);
var item = menu_add_item(128,rh-64,obj_button,false,"Back");
menu_edit_item(item,"w",96,"h",32);
var item = menu_add_item(rw-256,rh-64,obj_button,false,"Join Server");
menu_edit_item(item,"w",128,"h",32);

devices = audio_get_recorder_count();
menu_item[3,1].items = devices;
for(var i=0; i<devices; i++;)
	{
	device_info = audio_get_recorder_info(i);
	device_index[i] = device_info[?"index"];
	device_name[i] = device_info[?"name"];
	device_format[i] = device_info[?"data_format"];
	device_sample[i] = device_info[?"sample_rate"];
	device_stereo[i] = device_info[?"channels"];
	ds_map_destroy(device_info);
	
	menu_item[3,1].item[i] = device_name[i];
	}

cur_device = -1;
old_device = -1;
if (devices > 0)
	{
	old_device = 0;
	cur_device = 0;
	}
recording_channel = -1;
amplitude = 0;
amplitude_ease = 0;