menu_process();

switch(menu)
	{
	case 0: // username
		if (menu_item[0,1].output)
			menu = 1;
		if (menu_item[0,2].output)
			menu = 2;
		break;
	
	case 1: // server setup
		global.server_name = menu_item[1,1].output;
		if (string_digits(menu_item[1,3].output) != "")
			global.server_port = real(string_digits(menu_item[1,3].output));
		global.server_format = menu_item[1,5].output;
		global.server_downsample = menu_item[1,7].output;
		
		if (menu_item[1,8].output)
			menu = 0;
		menu_item[1,9].disabled = (string_length(global.server_name) < 4)
		if (menu_item[1,9].output)
			{
			if (string(menu_item[1,3].output) == "")
				global.server_port = 9817;
			
			// save user profile and settings
			save_profile();
			
			// remove ui objects
			for(var i=0; i<=menus; i++;)
				{
				for(var j=0; j<menu_items[i]; j++;)
					instance_destroy(menu_item[i,j]);
				}
			
			// create server
			instance_create_depth(0,0,0,obj_server);
			instance_destroy();
			exit;
			}
		break;
	
	case 2: // user profile
		global.name = menu_item[2,1].output;
		if (menu_item[2,3].output)
			{
			// change user avatar
			var file = get_open_filename("Images|*.png;*.jpg","");
			if (file != "") and (file_exists(file))
				{
				// remove existing user avatar
				if (sprite != spr_default_user) and (sprite_exists(sprite))
					sprite_delete(sprite);
				
				sprite = sprite_add(file,0,0,0,0,0);
				
				var surf = surface_create(64,64);
				surface_set_target(surf);
				draw_clear($000000);
				
				var w = sprite_get_width(sprite);
				var h = sprite_get_height(sprite);
				draw_sprite_ext(sprite,0,0,0,64/w,64/h,0,-1,1);
				
				surface_reset_target();
				
				if !(ds_exists(global.img_data,ds_type_grid))
					global.img_data = ds_grid_create(64,64);
				var buff = buffer_create(16384,buffer_grow,1);
				buffer_get_surface(buff,surf,buffer_surface_copy,0,0);
				for(var iy=0; iy<64; iy++;)
					{
					for(var ix=0; ix<64; ix++;)
						{
						var col = buffer_peek(buff,4*(ix + iy*64),buffer_u32);
						var hue = round(63*(color_get_hue(col)/255));
						var sat = round(15*(color_get_saturation(col)/255));
						var val = round(63*(color_get_value(col)/255));
						global.img_data[#ix,iy] = hue | (sat << 6) | (val << 10);
						}
					}
				
				buffer_delete(buff);
				surface_free(surf);
				}
			}
		if (menu_item[2,4].output)
			menu = 0;
		menu_item[2,5].disabled = (string_length(global.name) < 4)
		if (menu_item[2,5].output)
			menu = 3;
		break;
	
	case 3: // audio setup
		if (menu_item[3,1].output >= 0)
			cur_device = menu_item[3,1].output;
		
		global.gain = menu_item[3,3].output;
		global.gate = menu_item[3,5].output;
		menu_edit_item(menu_item[3,2],"text","Microphone Volume: "+string(round(global.gain*100))+"%");
		menu_edit_item(menu_item[3,4],"text","Noise Gate: "+string(round(global.gate*100))+"%");
		
		global.ptt = menu_item[3,7].output;

		if (menu_item[3,8].output)
			menu = 1;
		if (menu_item[3,9].output)
			menu = 4;
		
		// if not recording, start recording
		if (recording_channel == -1) and (cur_device >= 0)
			{
			recording_channel = audio_start_recording(device_index[cur_device]);
			show_debug_message("OBJ_MENU: RECORDING STARTED");
			}
		break;
	
	case 4: // connect to server
		global.connect_ip = menu_item[4,1].output;
		global.connect_port = menu_item[4,2].output;
		
		if (menu_item[4,3].output)
			menu = 3;
		if (menu_item[4,4].output)
			{
			if (string_digits(menu_item[4,2].output) != "")
				{
				// save user profile and settings
				save_profile();
				
				// destroy all ui objects
				for(var i=0; i<=menus; i++;)
					{
					for(var j=0; j<menu_items[i]; j++;)
						instance_destroy(menu_item[i,j]);
					}
				
				// remove custom sprites
				if (sprite_exists(sprite) and (sprite != spr_default_user))
					sprite_delete(sprite);
				
				// create the client and chat control
				instance_create_depth(0,0,0,obj_client);
				var inst = instance_create_depth(0,0,0,obj_chat_control);
				inst.device_index	= device_index[cur_device];
				inst.device_name	= device_name[cur_device];
				inst.device_sample	= device_sample[cur_device];
				inst.device_format	= device_format[cur_device];
				inst.device_stereo	= device_stereo[cur_device];
				inst.gain = global.gain;
				inst.gate = global.gate;
				
				instance_destroy();
				exit;
				}
			}
		break;
	}