time = get_timer();

// connection info
if (data_t_array[data_index] > data_array_max)
	data_array_max = ceil(data_t_array[data_index]/1024)*1024;
if (data_r_array[data_index] > data_array_max)
	data_array_max = ceil(data_r_array[data_index]/1024)*1024;
data_index++;
if (data_index > 179)
	data_index = 0;
data_t_array[data_index] = 0;
data_r_array[data_index] = 0;

if (time-stats_time >= sec)
	{
	stats_time = time;
	
	total_data_t += data_t; total_data_r += data_r;
	total_pack_t += pack_t; total_pack_r += pack_r;
	data_t = 0; data_r = 0;
	pack_t = 0; pack_r = 0;
	}

// heartbeat
if (time-heartbeat_time >= sec)
	{
	heartbeat_time = time;
	heartbeat_broadcast++;
	
	for(var i=0; i<max_user; i++;)
		{
		if !(connected[i])
			continue;
		
		var temp_info = user_info[i];
		temp_info[?"heartbeat_time"] = time;
		var miss = temp_info[?"heartbeat_miss"];
		temp_info[?"heartbeat_miss"] = miss+1;
		
		if (miss >= 5)
			{
			temp_info = user_info[i];
			log(string(temp_info[?"name"])+" timed out!");
			
			ds_map_delete(user_lookup,string(temp_info[?"ip"])+":"+string(temp_info[?"port"]));
			ds_grid_destroy(temp_info[?"img_data"]);
			ds_map_clear(temp_info);
			connected[i] = false;
			cur_user--;
			
			// tell remaining users about user leaving
			temp_buffer = buffer_create(16,buffer_fixed,1);
			buffer_seek(temp_buffer,buffer_seek_start,0);
			buffer_write(temp_buffer,buffer_u8,server_message.user_leave);
			buffer_write(temp_buffer,buffer_u8,1);
			buffer_write(temp_buffer,buffer_u8,i);
			server_queue_message(max_user,temp_buffer);
			}
		}
	
	var send_buffer = buffer_create(64,buffer_fixed,1);
	buffer_seek(send_buffer,buffer_seek_start,0);
	buffer_write(send_buffer,buffer_u8,server_message.heartbeat);
	
	if (heartbeat_broadcast >= 10)
		{
		// broadcast ping data to all users with heartbeat
		heartbeat_broadcast = 0;
		
		buffer_write(send_buffer,buffer_u8,true);
		buffer_write(send_buffer,buffer_u8,cur_user);
		
		for(var i=0; i<max_user; i++;)
			{
			if !(connected[i])
				continue;
			
			buffer_write(send_buffer,buffer_u8,i);
			buffer_write(send_buffer,buffer_u16,round(ds_map_find_value(user_info[i],"ping")/16));
			}
		}
	else
		{
		// simple heartbeat
		buffer_write(send_buffer,buffer_u8,false);
		}
	
	server_queue_message(max_user,send_buffer);
	}

// merge and send out queued messages
for(var i=0; i<max_user; i++;)
	{
	if !(connected[i])
		continue;
	
	if (messages[i] > 0)
		{
		var temp_buffer = buffer_create(MTU,buffer_fixed,1);
		
		var index = 0;
		var bytes = 1;
		var num = 0;
		do
			{
			var buff = ds_list_find_value(message_list[i],index*2 + 0);
			var size = ds_list_find_value(message_list[i],index*2 + 1);
			
			if (bytes+size >= MTU) // too big, skip it
				index++;
			else
				{
				buffer_copy(buff,0,size,temp_buffer,bytes);
				buffer_delete(buff);
				
				repeat(2)
					ds_list_delete(message_list[i],index*2);
				messages[i]--;
				
				bytes += size;
				num++;
				}
			}
		until (index >= messages[i])
		
		if (num > 0)
			{
			buffer_poke(temp_buffer,0,buffer_u8,num);
			
			temp_info = user_info[i];
			network_send_udp_raw(server,temp_info[?"ip"],temp_info[?"port"],temp_buffer,bytes);
			
			data_t += bytes;
			pack_t += 1;
			data_t_array[data_index] += bytes;
			}
		
		buffer_delete(temp_buffer);
		}
	}

if (keyboard_check_pressed(vk_f1))
	stats_graph = !stats_graph;