/// load_profile();

global.name = "";
global.connect_ip = "127.0.0.1";
global.connect_port = 9817;
global.server_name = "";
global.server_port = 9817;
global.server_format = 1;
global.server_downsample = 0;
global.ptt = 1;
global.gate = 0.1;
global.gain = 1;
global.img_data = -1;
sprite = spr_default_user;

var path = working_directory+"profile.ini";
if (file_exists(path))
	{
	var comp_buffer = buffer_load(path);
	var temp_buffer = buffer_decompress(comp_buffer);
	if (temp_buffer >= 0)
		{
		buffer_seek(temp_buffer,buffer_seek_start,0);
		var v = buffer_read(temp_buffer,buffer_u8);
		if (v == version)
			{
			// load profile settings
			global.name = buffer_read(temp_buffer,buffer_string);
			global.connect_ip = buffer_read(temp_buffer,buffer_string);
			global.connect_port = buffer_read(temp_buffer,buffer_u16);
			global.server_name = buffer_read(temp_buffer,buffer_string);
			global.server_port = buffer_read(temp_buffer,buffer_u16);
			global.server_format = buffer_read(temp_buffer,buffer_u8);
			global.server_downsample = buffer_read(temp_buffer,buffer_u8);
			global.ptt = buffer_read(temp_buffer,buffer_u8);
			global.gate = buffer_read(temp_buffer,buffer_f32);
			global.gain = buffer_read(temp_buffer,buffer_f32);
			
			// load user avatar data
			if !(ds_exists(global.img_data,ds_type_grid))
				global.img_data = ds_grid_create(64,64);
			
			// create user avatar from data
			var surf = surface_create(64,64);
			surface_set_target(surf);
			draw_clear($000000);
			
			for(var iy=0; iy<64; iy++;)
				{
				for(var ix=0; ix<64; ix++;)
					{
					var data = buffer_read(temp_buffer,buffer_u16);
					ds_grid_set(global.img_data,ix,iy,data);
					var hue = (data)		& 63;
					var sat = (data >> 6)	& 15;
					var val = (data >> 10)	& 63;
					draw_point_color(ix,iy,make_color_hsv((hue/63)*255,(sat/15)*255,(val/63)*255));
					}
				}
		
			surface_reset_target();
			
			sprite = sprite_create_from_surface(surf,0,0,64,64,0,0,0,0);
			surface_free(surf);
			}
		buffer_delete(temp_buffer);
		}
	buffer_delete(comp_buffer);
	}

// no user avatar loaded, user default sprite
if (sprite == spr_default_user)
	{
	var surf = surface_create(64,64);
	surface_set_target(surf);
	draw_clear($000000);
	
	var w = sprite_get_width(sprite);
	var h = sprite_get_height(sprite);
	draw_sprite_ext(sprite,0,0,0,64/w,64/h,0,-1,1);
	
	surface_reset_target();
	
	if !(ds_exists(global.img_data,ds_type_grid))
		global.img_data = ds_grid_create(64,64);
	var buff = buffer_create(16384,buffer_grow,1);
	buffer_get_surface(buff,surf,buffer_surface_copy,0,0);
	for(var iy=0; iy<64; iy++;)
		{
		for(var ix=0; ix<64; ix++;)
			{
			var col = buffer_peek(buff,4*(ix + iy*64),buffer_u32);
			var hue = round(63*(color_get_hue(col)/255));
			var sat = round(15*(color_get_saturation(col)/255));
			var val = round(63*(color_get_value(col)/255));
			global.img_data[#ix,iy] = hue | (sat << 6) | (val << 10);
			}
		}
	
	buffer_delete(buff);
	surface_free(surf);
	}