/// server_handle_packet();

buffer_seek(buffer,buffer_seek_start,0);
_messages = buffer_read(buffer,buffer_u8);

repeat(_messages)
	{
	_message_id = buffer_read(buffer,buffer_u8);
	if (_message_id < user_message.size)
		show_debug_message(global.user_message_text[_message_id]);
	
	switch(_message_id)
		{
		case user_message.welcome:
			_byte = buffer_read(buffer,buffer_u8);
			_name = buffer_read(buffer,buffer_string);
			
			if (cur_user >= max_user) or (_byte != 69) or (user_id != undefined)
				{
				temp_buffer = buffer_create(16,buffer_fixed,1);
				buffer_seek(temp_buffer,buffer_seek_start,0);
				buffer_write(temp_buffer,buffer_u8,1);
				buffer_write(temp_buffer,buffer_u8,server_message.error);
				var _size = buffer_tell(temp_buffer);
				network_send_udp(server,ip,port,temp_buffer,_size);
				buffer_delete(temp_buffer);
				
				data_t += _size;
				pack_t += 1;
				
				break;
				}
			
			for(var i=0; i<max_user; i++;)
				{
				if !(connected[i])
					{
					user_id = i;
					break;
					}
				}
			
			log(string(_name)+" connected!");
			
			temp_info = user_info[user_id];
			temp_info[?"ip"] = ip;
			temp_info[?"port"] = port;
			temp_info[?"name"] = _name;
			temp_info[?"ping"] = 0;
			temp_info[?"heartbeat_time"] = get_timer();
			temp_info[?"heartbeat_miss"] = 0;
			
			temp_info[?"img_data"] = ds_grid_create(64,64);
			temp_info[?"img_ready"] = false;
			temp_info[?"img_sectors"] = 0;
			
			ds_map_add(user_lookup,string(ip)+":"+string(port),user_id);
			connected[user_id] = true;
			all_user++;
			cur_user++;
			
			// tell new user about previous users
			temp_buffer = buffer_create(64,buffer_fixed,1);
			buffer_seek(temp_buffer,buffer_seek_start,0);
			buffer_write(temp_buffer,buffer_u8,server_message.welcome);
			buffer_write(temp_buffer,buffer_u8,user_id);
			buffer_write(temp_buffer,buffer_u8,max_user);
			buffer_write(temp_buffer,buffer_string,server_name);
			buffer_write(temp_buffer,buffer_u8,server_format);
			buffer_write(temp_buffer,buffer_u8,server_downsample);
			server_queue_message(user_id,temp_buffer);
			
			temp_buffer = buffer_create(256,buffer_fixed,1);
			buffer_seek(temp_buffer,buffer_seek_start,0);
			buffer_write(temp_buffer,buffer_u8,server_message.user_join);
			buffer_write(temp_buffer,buffer_u8,cur_user);
			for(var i=0; i<max_user; i++;)
				{
				if !(connected[i])
					continue;
				
				buffer_write(temp_buffer,buffer_u8,i);
				buffer_write(temp_buffer,buffer_string,ds_map_find_value(user_info[i],"name"));
				}
			server_queue_message(user_id,temp_buffer);
			
			// tell existing users about new user
			for(var i=0; i<max_user; i++;)
				{
				if !(connected[i]) or (i == user_id)
					continue;
				
				temp_buffer = buffer_create(64,buffer_fixed,1);
				buffer_seek(temp_buffer,buffer_seek_start,0);
				buffer_write(temp_buffer,buffer_u8,server_message.user_join);
				buffer_write(temp_buffer,buffer_u8,1);
				buffer_write(temp_buffer,buffer_u8,user_id);
				buffer_write(temp_buffer,buffer_string,_name);
				server_queue_message(i,temp_buffer);
				}
			
			break;
		
		case user_message.goodbye:
			temp_info = user_info[user_id];
			log(string(temp_info[?"name"])+" disconnected!");
			
			ds_grid_destroy(ds_map_find_value(user_info[user_id],"img_data"));
			ds_map_clear(user_info[user_id]);
			
			ds_map_delete(user_lookup,string(ip)+":"+string(port));
			connected[user_id] = false;
			cur_user--;
			
			// tell remaining users about user leaving
			for(var i=0; i<max_user; i++;)
				{
				if !(connected[i])
					continue;
				
				temp_buffer = buffer_create(16,buffer_fixed,1);
				buffer_seek(temp_buffer,buffer_seek_start,0);
				buffer_write(temp_buffer,buffer_u8,server_message.user_leave);
				buffer_write(temp_buffer,buffer_u8,1);
				buffer_write(temp_buffer,buffer_u8,user_id);
				server_queue_message(i,temp_buffer);
				}
			
			break;
		
		case user_message.user_image_upload:
			var sector = buffer_read(buffer,buffer_u8);
			var sectors = ds_map_find_value(user_info[user_id],"img_sectors");
			if (sectors != sectors | (1 << sector))
				{
				var temp_data = ds_map_find_value(user_info[user_id],"img_data");
				
				var ind = 0;
				// new sector, read the data into the grid
				for(var iy=sector*4; iy<sector*4+4; iy++;)
					{
					for(var ix=0; ix<64; ix++;)
						temp_data[#ix,iy] = buffer_read(buffer,buffer_u16);
					}
			
				sectors = sectors | (1 << sector);
				ds_map_set(user_info[user_id],"img_sectors",sectors);
			
				if (sectors == 65535)
					ds_map_set(user_info[user_id],"img_ready",true);
				}
			else
				{
				// skip the data, we've already read this sector
				buffer_seek(buffer,buffer_seek_start,buffer_tell(buffer)+512);
				}
			
			// reply to the upload request
			temp_buffer = buffer_create(16,buffer_fixed,1);
			buffer_seek(temp_buffer,buffer_seek_start,0);
			buffer_write(temp_buffer,buffer_u8,server_message.user_image_upload);
			buffer_write(temp_buffer,buffer_u16,sectors);
			server_queue_message(user_id,temp_buffer);
			break;
		
		case user_message.user_image_download:
			var temp_id = buffer_read(buffer,buffer_u8);
			var sector = buffer_read(buffer,buffer_u8);
			
			if (connected[temp_id]) and (ds_map_find_value(user_info[temp_id],"img_ready"))
				{
				var temp_data = ds_map_find_value(user_info[temp_id],"img_data");
				
				temp_buffer = buffer_create(16+512,buffer_fixed,1);
				buffer_seek(temp_buffer,buffer_seek_start,0);
				buffer_write(temp_buffer,buffer_u8,server_message.user_image_download);
				buffer_write(temp_buffer,buffer_u8,temp_id);
				buffer_write(temp_buffer,buffer_u8,sector);
				
				for(var iy=sector*4; iy<sector*4+4; iy++;)
					{
					for(var ix=0; ix<64; ix++;)
						buffer_write(temp_buffer,buffer_u16,temp_data[#ix,iy]);
					}
				
				server_queue_message(user_id,temp_buffer);
				}
			break;
		
		case user_message.user_message:
			var chat = buffer_read(buffer,buffer_string);
			
			temp_buffer = buffer_create(16+128,buffer_fixed,1);
			buffer_seek(temp_buffer,buffer_seek_start,0);
			buffer_write(temp_buffer,buffer_u8,server_message.user_message);
			buffer_write(temp_buffer,buffer_u8,user_id);
			buffer_write(temp_buffer,buffer_string,chat);
			server_queue_message(max_user,temp_buffer);
			break;
		
		case user_message.user_voice:
			var transmit = buffer_read(buffer,buffer_u8);
			if (transmit)
				{
				var stereo = buffer_read(buffer,buffer_u8);
				var sample = buffer_read(buffer,buffer_u16);
				var bytes  = buffer_read(buffer,buffer_u16);
				
				var pos1 = buffer_tell(buffer);
				
				var temp_buffer = buffer_create(16+bytes,buffer_fixed,1);
				buffer_seek(temp_buffer,buffer_seek_start,0);
				buffer_write(temp_buffer,buffer_u8,server_message.user_voice);
				buffer_write(temp_buffer,buffer_u8,user_id);
				buffer_write(temp_buffer,buffer_u8,true);
				buffer_write(temp_buffer,buffer_u8,stereo);
				buffer_write(temp_buffer,buffer_u16,sample);
				buffer_write(temp_buffer,buffer_u16,bytes);
				
				var pos2 = buffer_tell(temp_buffer);
				
				for(var i=0; i<bytes; i++;)
					{
					var val = buffer_peek(buffer,pos1+i,buffer_u8);
					buffer_poke(temp_buffer,pos2+i,buffer_u8,val);
					}
				
				// rebroadcast voice data
				for(var i=0; i<max_user; i++;)
					{
					if !(connected[i]) or (i == user_id)
						continue;
					
					var send_buffer = buffer_create(pos2+bytes,buffer_fixed,1);
					buffer_copy(temp_buffer,0,pos2+bytes,send_buffer,0);
					
					server_queue_message(i,send_buffer,pos2+bytes);
					}
				
				// seek back to where we left off reading from the async buffer
				buffer_seek(buffer,buffer_seek_start,pos1+bytes);
				}
			else
				{
				// user stopped transmitting audio
				for(var i=0; i<max_user; i++;)
					{
					if !(connected[i]) or (i == user_id)
						continue;
				
					temp_buffer = buffer_create(16,buffer_fixed,1);
					buffer_seek(temp_buffer,buffer_seek_start,0);
					buffer_write(temp_buffer,buffer_u8,server_message.user_voice);
					buffer_write(temp_buffer,buffer_u8,user_id);
					buffer_write(temp_buffer,buffer_u8,false);
					server_queue_message(i,temp_buffer);
					}
				}
			break;
		
		case user_message.heartbeat:
			temp_info = user_info[user_id];
			temp_info[?"heartbeat_miss"] = 0;
			temp_info[?"ping"] = get_timer()-temp_info[?"heartbeat_time"];
			break;
		}
	}